tigase.xmpp.impl

## Class PresenceOffline

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.impl.PresenceAbstract
      - - tigase.xmpp.impl.PresenceOffline

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, XMPPImplIfc, XMPPProcessorIfc, XMPPStopListenerIfc

      public class PresenceOffline
      extends PresenceAbstract
      implements XMPPStopListenerIfc

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `CACHE_SIZE_PROP_KEY`
    `protected static String` | `ID`
    `static String` | `PRESENCE_REPO_CLASS_PROP_KEY`
    `static String` | `PRESENCE_REPO_URI_PROP_KEY`

    - ### Fields inherited from class tigase.xmpp.impl.PresenceAbstract

      `PRESENCE_ELEMENT_NAME, PRESENCE_PROBE_FULL_JID_KEY, probeFullJID, roster_util, SKIP_OFFLINE_PROP_KEY, SKIP_OFFLINE_SYS_PROP_KEY, skipOffline, USERS_STATUS_CHANGES, XMLNS`

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PresenceOffline()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Map<String,Object> settings)` Method `init` is called just after the plugin has been loaded into memory.
    `protected boolean` | `isNotOnlySession(XMPPResourceConnection session)`
    `protected boolean` | `isSubscriptionValid(BareJID owner, BareJID contact)`
    `protected Element` | `loadPresenceFromRepo(BareJID stanzaTo)`
    `void` | `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
    `void` | `stopped(XMPPResourceConnection session, Queue<Packet> results, Map<String,Object> settings)` Performs additional processing upon closing user session (user either disconnects or logs-out).

    - ### Methods inherited from class tigase.xmpp.impl.PresenceAbstract

      `broadcastProbe, concurrentQueuesNo, forwardPresence, getRosterUtil, initSettings, prepareProbe, requiresPresenceSending, sendPresence, sendPresence, updatePresenceChange, updateUserResources`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `id, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getStatistics, isSupporting, supElements, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getStatistics, id, isSupporting, supDiscoFeatures, supElementNamePaths, supElements, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Field Detail

    - #### PRESENCE_REPO_CLASS_PROP_KEY

          public static final String PRESENCE_REPO_CLASS_PROP_KEY

      See Also:
        Constant Field Values

    - #### PRESENCE_REPO_URI_PROP_KEY

          public static final String PRESENCE_REPO_URI_PROP_KEY

      See Also:
        Constant Field Values

    - #### CACHE_SIZE_PROP_KEY

          public static final String CACHE_SIZE_PROP_KEY

      See Also:
        Constant Field Values

    - #### ID

          protected static final String ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PresenceOffline

          public PresenceOffline()

  - ### Method Detail

    - #### init

          public void init(Map<String,Object> settings)
                    throws TigaseDBException

      Description copied from interface: `XMPPImplIfc`
      Method `init` is called just after the plugin has been loaded into memory. The idea behind this is to allow it to initialize or check the database. This might be especially useful for plugins which want to have a database access via non-standard stored procedures or need schema upgrade.
      Specified by:
        `init` in interface `XMPPImplIfc`
      Overrides:
        `init` in class `XMPPProcessor`
      Parameters:
        `settings` - is a Map with initial processor settings from the configuration file.
      Throws:
        `TigaseDBException`

    - #### process

          public void process(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository repo,
                              Queue<Packet> results,
                              Map<String,Object> settings)
                       throws XMPPException

      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Throws:
        `XMPPException`

    - #### stopped

          public void stopped(XMPPResourceConnection session,
                              Queue<Packet> results,
                              Map<String,Object> settings)

      Description copied from interface: `XMPPStopListenerIfc`
      Performs additional processing upon closing user session (user either disconnects or logs-out).
      Specified by:
        `stopped` in interface `XMPPStopListenerIfc`
      Parameters:
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.

    - #### isNotOnlySession

          protected boolean isNotOnlySession(XMPPResourceConnection session)

    - #### isSubscriptionValid

          protected boolean isSubscriptionValid(BareJID owner,
                                                BareJID contact)

    - #### loadPresenceFromRepo

          protected Element loadPresenceFromRepo(BareJID stanzaTo)

Copyright © 2018 "Tigase, Inc.". All rights reserved.